//gcc/linux: cc expfont.c ../rfxswf.c -funsigned-char -ljpeg -o ../bin/expfont

#ifdef __NT__

#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include "..\rfxswf.h"

#else

#include <stdio.h>
#include <fcntl.h>
#include "../rfxswf.h"
#define O_BINARY 0

#endif

SWF swf;
  
void fontcallback(U16 id,U8 * name)
{ LPSWFFONT font;

  int f;
  char s[500];
  
  FontExtract(&swf,id,&font);
  sprintf(s,"%s%s%s.efont",name,FontIsBold(font)?" bold":"",FontIsItalic(font)?" italic":"");

  f = open(s,O_BINARY|O_RDWR|O_CREAT|O_TRUNC);
  if (f>=0)
  { int res = FontExport(f,font);
    if (res<0) fprintf(stderr,"Font export failed: %s\n",s);
    close(f);
  }
  
  FontFree(font);
/*
  f = open(s,O_BINARY|O_RDONLY);
  if (f>=0)
  { if (FontImport(f,&font)<0) fprintf(stderr,"Error reimporting font.\n");
      else fprintf(stderr,"%s successfuly reimported.\n",font->name);
    close(f);
    FontFree(font);
  }
  else fprintf(stderr,"File error: %s\n",s);
*/
}

int main (int argc,char ** argv)
{ int f;

  if (argc>1)
  { f = open(argv[1],O_BINARY|O_RDONLY);
    if (f>=0)
    { if FAILED(ReadSWF(f,&swf))
      { fprintf(stderr,"%s is not a valid SWF file or contains errors.\n",argv[1]);
        close(f);
      }
      else
      { close(f);
        FontEnumerate(&swf,&fontcallback);
        FreeTags(&swf);
      }
    } else fprintf(stderr,"File not found: %s\n",argv[1]);
  }
  else fprintf(stderr,"\nreflex SWF Font Export Utility\n(w) 2000 by Rainer Boehme <rb@reflex-studio.de>\n\nUsage: expfont filename.swf\n");
  
  return 0;
}

