/* swfoutput.h
   Header file for swfoutput.cc (and swfoutput_x11.cc).

   Part of the swftools package.

   Copyright (c) 2001 Matthias Kramm <kramm@quiss.org> 

   This file is distributed under the GPL, see file COPYING for details */

#ifndef __swfoutput_h__
#define __swfoutput_h__

#include <t1lib.h>

typedef long int twip;

struct swfmatrix {
    double m11,m12,m21,m22,m13,m23;
};

struct swfcoord {
    twip x;
    twip y;
};

struct swfoutput 
{
    int t1font;
    double fontm11,fontm12,fontm21,fontm22;
};


void swfoutput_init(struct swfoutput*, char*filename, int sizex, int sizey);
void swfoutput_setprotected(); //write PROTECT tag

void swfoutput_newpage(struct swfoutput*);

 int swfoutput_setfont(struct swfoutput*, int t1font);
void swfoutput_setfontmatrix(struct swfoutput*,double,double,double,double);
void swfoutput_drawchar(struct swfoutput*,double x,double y,char a);

void swfoutput_drawpath(struct swfoutput*output, T1_OUTLINE*outline, struct swfmatrix*m);

void swfoutput_destroy(struct swfoutput*);

#endif //__swfoutput_h__
